#include <iostream>

using namespace std;

int main()
{
    int n; cin >> n;
    int O, A, B, AB;
    cin >> O >> A >> B >> AB;
    string grupa[n];
    int koliko[n];
    int rezO[n] = {0}, rezA[n] = {0}, rezB[n] = {0}, rezAB[n] = {0};
    bool moguce = true;

    for(int i = 0; i < n; i++)
    {
        cin >> grupa[i] >> koliko[i];
    }

    for(int i = 0; i < n; i++)
    {
        if(grupa[i] == "O")
        {
            if(O >= koliko[i])
            {
                O -= koliko[i];
                rezO[i] = koliko[i];
                koliko[i] = 0;
            }
            else
            {
                moguce = false;
                break;
            }
        }
        else if(grupa[i] == "A")
        {
            if(A >= koliko[i])
            {
                A -= koliko[i];
                rezA[i] = koliko[i];
                koliko[i] = 0;
            }
            else
            {
                rezA[i] = A;
                koliko[i] -= A;
                A = 0;

                if(O >= koliko[i])
                {
                    O -= koliko[i];
                    rezO[i] = koliko[i];
                    koliko[i] = 0;
                }
                else
                {
                    moguce = false;
                    break;
                }
            }
        }
        else if(grupa[i] == "B")
        {
            if(B >= koliko[i])
            {
                B -= koliko[i];
                rezB[i] = koliko[i];
                koliko[i] = 0;
            }
            else
            {
                rezB[i] = B;
                koliko[i] -= B;
                B = 0;

                if(O >= koliko[i])
                {
                    O -= koliko[i];
                    rezO[i] = koliko[i];
                    koliko[i] = 0;
                }
                else
                {
                    moguce = false;
                    break;
                }
            }
        }
        else
        {
            continue;
        }
    }

    for(int i = 0; i < n; i++)
    {
        if(grupa[i] == "AB")
        {
            if(AB >= koliko[i])
            {
                AB -= koliko[i];
                rezAB[i] = koliko[i];
                koliko[i] = 0;
            }
            else
            {
                rezAB[i] = AB;
                koliko[i] -= AB;
                AB = 0;

                if(A >= koliko[i])
                {
                    A -= koliko[i];
                    rezA[i] = koliko[i];
                    koliko[i] = 0;
                }
                else
                {
                    rezA[i] = A;
                    koliko[i] -= A;
                    A = 0;

                    if(B >= koliko[i])
                    {
                        B -= koliko[i];
                        rezB[i] = koliko[i];
                        koliko[i] = 0;
                    }
                    else
                    {
                        if(O >= koliko[i])
                        {
                            O -= koliko[i];
                            rezO[i] = koliko[i];
                            koliko[i] = 0;
                        }
                        else
                        {
                            moguce = false;
                            break;
                        }
                    }
                }
            }
        }
    }

    if(!moguce)
        cout << "nemoguce" << endl;
    else
    {
        cout << "moguce" << endl;

        for(int i = 0; i < n; i++)
        {
            cout << rezO[i] << " " << rezA[i] << " " << rezB[i] << " " << rezAB[i] << endl;
        }
    }

    return 0;
}